unit uFuncoes;

interface
{Uses
Windows,SysUtils;
 }

//function Codificar(Armazena : string ; Chave : integer) : string;
//function Decodificar(Armazena : string ; Chave : integer) : string;
//Function SerialNum(FDrive:String) :String;
function Alltrim(const Search: string): string;
//function IsInteger(TestaString: String) : boolean;
//function IsWindowInMemory (WndTitle : String) : Boolean;
implementation
{function IsInteger(TestaString: String) : boolean;
begin
try
  StrToInt(TestaString);
except
  On EConvertError do
     result := False;
  else
     result := True;
  end;
end;

function IsWindowInMemory (WndTitle : String) : Boolean;
var
hSem : THandle;
hWndMe : HWnd;
begin
Result := False;
hSem := CreateSemaphore (nil, 0, 1, 'NomeDoSemaforo');
if (hSem <> 0) and (GetLastError() = ERROR_ALREADY_EXISTS) then
    begin
    CloseHandle (hSem);
    hWndMe := FindWindow (nil, PChar (WndTitle));
    SetWindowText (hWndMe, 'olzfgowtjoyug');
    hWndMe := FindWindow (nil, PChar (WndTitle));
    if hWndMe <> 0 then
       begin
       if IsIconic (hWndMe) then
          begin
          ShowWindow (hWndMe, SW_SHOWNORMAL);
          end
       else
          begin
          SetForegroundWindow (hWndMe);
          end;
       end;
    Result := True;
    end;
end;




function Codificar(Armazena : string ; Chave : integer) : string;
var
 Resultado : string;
 Temporario : Char;
 I, CodificaIndex : integer;
begin
 Resultado := '';
 Temporario:= ' ';
 for I := 1 to length(Armazena) do
 begin
  for CodificaIndex := 1 to Chave do
  begin
    Temporario:= Succ(Armazena[I]);
    Armazena[I]:= Temporario;
  end;
  Resultado:= Resultado + Temporario;
 end;
 Codificar:= Resultado;
end;

function Decodificar(Armazena : string ; Chave : integer) : string;
var
 Resultado : string;
 Temporario : Char;
 I, DecodificaIndex : integer;
begin
 Resultado := '';
 Temporario:= ' ';
 for I := 1 to length(Armazena) do
 begin
  for DecodificaIndex := 1 to Chave do
  begin
    Temporario:= Pred(Armazena[I]);
    Armazena[I]:= Temporario;
  end;
  Resultado:= Resultado + Temporario;
 end;
 Decodificar:= Resultado;
end;

Function SerialNum(FDrive:String) :String;
Var Serial:DWord;
DirLen,Flags: DWord;
DLabel : Array[0..11] of Char;
begin
   Try
      GetVolumeInformation(PChar(FDrive+':\'),dLabel,12,@Serial,DirLen,Flags,nil,0);
      Result := IntToHex(Serial,8);
   Except Result :='';
   end;
end;
 }
function Alltrim(const Search: string): string;
{Remove os espaos em branco de ambos os lados da string}
const
BlackSpace = [#33..#126];
var
Index: byte;
begin
Index:=1;
while (Index <= Length(Search)) and not (Search[Index] in BlackSpace) do
       begin
       Index:=Index + 1;
       end;
Result:=Copy(Search, Index, 255);
Index := Length(Result);
while (Index > 0) and not (Result[Index] in BlackSpace) do
       begin
       Index:=Index - 1;
       end;
Result := Copy(Result, 1, Index);
end;


end.
