unit uPrincipal;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, ExtCtrls, Mask, StdCtrls, Buttons, ComCtrls, spBina,
  Db, DBTables, Grids, DBGrids, ImgList, ToolWin;

type
  TfBina = class(TForm)
    Detector2: TTimer;
    GroupBox1: TGroupBox;
    Panel2: TPanel;
    GroupBox2: TGroupBox;
    GroupBox3: TGroupBox;
    Label1: TLabel;
    ListBox1: TListBox;
    ListBox2: TListBox;
    Label2: TLabel;
    BitBtn1: TBitBtn;
    tbFones: TTable;
    tbFonesRegistro_ID: TAutoIncField;
    tbFonesNome: TStringField;
    tbFonesDDD: TStringField;
    dtChamadas: TDataSource;
    tbFonesFone: TStringField;
    tbChamadas: TTable;
    tbChamadasRegistro_ID: TAutoIncField;
    tbChamadasData: TDateField;
    tbChamadasHora: TStringField;
    DBGrid1: TDBGrid;
    tbChamadasDDD: TStringField;
    tbChamadasFone: TStringField;
    tbChamadasNome: TStringField;
    BitBtn2: TBitBtn;
    Button1: TButton;
    dsFones: TDataSource;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Edit1: TEdit;
    Edit2: TEdit;
    MaskEdit1: TMaskEdit;
    editFone: TEdit;
    Button2: TButton;
    ToolBar1: TToolBar;
    bAtivar: TToolButton;
    bSetup: TToolButton;
    bDesativar: TToolButton;
    ToolButton4: TToolButton;
    ImageList1: TImageList;
    procedure Detector2Timer(Sender: TObject);
    procedure Panel2Click(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure ToolButton4Click(Sender: TObject);
    procedure bDesativarClick(Sender: TObject);
    procedure bSetupClick(Sender: TObject);
    procedure bAtivarClick(Sender: TObject);
  private
    { Private declarations }
  public
    texto, porta, vDDD : string;
    segundos, ativo, p3, p4 : integer;

  end;

var
  fBina: TfBina;
  SP : TspBina;

implementation

uses spBinaSetup, uFuncoes, uCadastrar;

{$R *.DFM}

procedure TfBina.Detector2Timer(Sender: TObject);
Var
status : string;
begin

 // se estiver ativo
 if ativo = 1 then
    inc(segundos);

 // Falta resistor
 if FormConfig.varOcupado > 0 then begin
    ListBox1.Clear;
    ListBox2.Clear;
    Panel2.Caption := 'Falta o Resistor';
//    PageControl1.ActivePage := TabSheet4;
    Detector2.Enabled := false;
    ShowMessage('A Chave no est na posio BINA, ou o RESISTOR '+
              'no est presente!'+#13+' O SuperBina ser desativado!');
    bAtivar.Enabled:=True;
    bDesativar.Enabled:=False;
    bSetup.Enabled:=True;
              // O desativamento ocorrera no FormConfig
  end;
  // mensagem de envio dos comandos
 if (FormConfig.estagio = 1) and (p4 = 0)  then begin
     Label1.Caption := 'Enviando o '+
                       IntToStr(FormConfig.ListBox1.ItemIndex+1)+
                       ' Comando...';
     ListBox1.Clear;
     ListBox2.clear;
     ListBox1.Items.add(FormConfig.chave);
     ListBox2.Items.add(trim(FormConfig.cmdResult));
 end;
 //Mensagens do painel do Status e no Ttulo do Form
 case FormConfig.estagio  of
      0: status := 'Desativado';
      1: status := 'Ativando...';
      2: status := 'Fone Detectado';
      4: status := 'Ativado';
 end;
 if status='Ativando...' then fbina.tag:=0;
 Panel2.Caption := status;
 fBina.Caption := 'Identificador de Chamadas - '+status;
 if FormConfig.Detectado = 2 then
    fBina.Caption := 'Chamada Detectada';

 // Mostrar painel de Status
 if (FormConfig.estagio = 4) and (p4 = 0)  then begin
      ListBox1.Clear;
      ListBox2.Clear;
      Panel2.Font.Color :=  clBlue;
      Label1.Caption := 'Ultimo comando enviado: '+
      IntToStr(FormConfig.ListBox1.ItemIndex+1);
      ListBox1.Items.add(FormConfig.cmd[FormConfig.cmdAT]);
      ListBox2.Items.add(FormConfig.cmdResult);
//      PageControl1.ActivePage := TabSheet4;
      p4 := 1;
 end;

 //Fone Detectado
 if FormConfig.Detectado = 2 then
    begin
      Application.Restore;
      ListBox1.Items.Clear;
      ListBox2.Items.Clear;
      Panel2.Font.Color :=  clNavy;
      Label1.Caption := 'Ultimo comando enviado: '+IntToStr(FormConfig.cmdAT+1);
      ListBox1.Items.add(FormConfig.cmd[FormConfig.cmdAT]);
      edit1.Text         := FormConfig.Tipo;
      edit2.text         := FormConfig.vDDD;
      MaskEdit1.EditMask := FormConfig.mascara;
      MaskEdit1.text     := FormConfig.Fone;
      tbFones.IndexName:='Indice';
      tbFones.First;
      if tbFones.FindKey([Alltrim(formConfig.vddd)+Alltrim(formConfig.fone)]) then
         Begin
            editfone.Text:=tbFonesNome.Value;
//            tbChamadasNome.Value:=tbFonesNome.Value;
         End
      else
         Begin
            editfone.text:='Nmero no cadastrado';
         End;
         if fBina.Tag=0 then
            Begin
               tbChamadas.Insert;
               tbChamadasData.Value:=date;
               tbChamadasHora.Value:=TimeToStr(time);
               tbChamadasDDD.Value:=formConfig.vDDD;
//               if Copy(formConfig.Fone,8,1)<>' ' then
//                  tbChamadasFone.Value:=Copy(formConfig.Fone,1,4)+'-'+Copy(formConfig.Fone,5,4)
//               Else
//                  tbChamadasFone.Value:=Copy(formConfig.Fone,1,3)+'-'+Copy(formConfig.Fone,5,4);
               tbChamadasFone.Value:=maskedit1.Text;    //formConfig.fone;
               tbChamadasNome.Value:=editFone.Text;
               tbChamadas.Post;
               fBina.Tag:=1;
            End;
   end;

  // Resseta  o timer para evitar estouro na var 'segundos'
 if segundos > 60  then
    segundos := 10;

end;

procedure TfBina.Panel2Click(Sender: TObject);
begin
// PageControl1.ActivePage := TabSheet1;
end;

procedure TfBina.FormPaint(Sender: TObject);
begin
//PageControl1.ActivePage := TabSheet1;
end;

procedure TfBina.FormShow(Sender: TObject);
begin
tbChamadas.Open;
tbFones.open;
bAtivar.Click;
//PageControl1.ActivePage := TabSheet1;
end;

procedure TfBina.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 Action := caFree;
end;


procedure TfBina.BitBtn1Click(Sender: TObject);
begin
edit1.clear;
edit2.clear;
maskedit1.Clear;
end;

procedure TfBina.BitBtn2Click(Sender: TObject);
begin
If MessageDlg('Tem certeza de que deseja apagar TODAS as chamadas?',mtConfirmation,[mbYes,mbNo],0) = 6 then
   tbChamadas.EmptyTable;
end;

procedure TfBina.Button1Click(Sender: TObject);
begin
tbFones.insert;
tbFonesFone.Value:=tbChamadasFone.Value;
fCadastrar.Show;
fCadastrar.dbEdit1.SetFocus;
end;

procedure TfBina.Button2Click(Sender: TObject);
begin
If MessageDlg('Tem certeza de que deseja apagar ESTA chamadaa?',mtConfirmation,[mbYes,mbNo],0) = 6 then
   tbChamadas.Delete;

end;

procedure TfBina.ToolButton4Click(Sender: TObject);
begin
 if ativo = 1 then
   begin
    bDesativar.Click;
    close;
   end
  else
    close;
end;

procedure TfBina.bDesativarClick(Sender: TObject);
begin
 if ativo = 1 then begin
  //Desativar
  segundos := 0;
  ativo := 0;
  Detector2.Enabled := false;
  FormConfig.Button3.Click;

//  AtivarSuperBina1.Enabled := true;
//  Configurar1.Enabled := true;
 // Desativar1.Enabled := false;
  bAtivar.Enabled := true;
  bSetup.Enabled := true;
  bDesativar.Enabled := false;
  Panel2.Font.Color := clRed;
//  PageControl1.ActivePage := TabSheet4;
  end;
end;

procedure TfBina.bSetupClick(Sender: TObject);
begin
// Se estiver destivado...
 if ativo = 0 then begin
    //Setup
    segundos := 0;
//    AtivarSuperBina1.Enabled := true;
 //   Configurar1.Enabled := true;
 //   Desativar1.Enabled := false;

    bAtivar.Enabled := true;
    bSetup.Enabled := true;
    bDesativar.Enabled := false;

    //Desliga o Detector
    Detector2.Enabled := false;

    //Chama Setup
    SP.ShowATComandSetup(true,false,false,porta, vDDD);
    bSetup.Enabled := true;
  end;
end;

procedure TfBina.bAtivarClick(Sender: TObject);
begin
 //Ativar
 if ativo = 0 then begin
   Panel2.Font.Color := clGreen;
   segundos:= 0;
   Ativo   := 1;
   p4      := 0;
//   AtivarSuperBina1.Enabled := false;
//   Configurar1.Enabled := false;
//   Desativar1.Enabled := true;

   bAtivar.Enabled := false;
   bSetup.Enabled := false;
   bDesativar.Enabled := true;

   Detector2.Enabled := true;

   //Ativar SuperBina
  // Setup=no, Ativar=SIM, Desativar=no, porta=porta, DDD=vDDD;
   SP.ShowATComandSetup(false,true,false, porta, vDDD);
//   PageControl1.ActivePage := TabSheet2;
   end;
end;

end.
